package server

import (
	"fmt"
	"local/router"
	"net/http"
)

func (s *Server) Routes() error {
	wildcard := router.Wildcard
	endpoints := []struct {
		path    string
		handler http.HandlerFunc
	}{
		{
			path:    fmt.Sprintf("/upserts"),
			handler: s.gzip(s.authenticate(s.upserts)),
		},
		{
			path:    fmt.Sprintf("/list"),
			handler: s.gzip(s.authenticate(s.list)),
		},
		{
			path:    fmt.Sprintf("%s%s", wildcard, wildcard),
			handler: s.gzip(s.authenticate(s.static)),
		},
	}

	for _, endpoint := range endpoints {
		if err := s.Add(endpoint.path, endpoint.handler); err != nil {
			return err
		}
	}
	return nil
}

func (s *Server) static(w http.ResponseWriter, r *http.Request) {
	s.fileServer.ServeHTTP(w, r)
}
